<script>
    import { getDateTimeTickInfo } from './datetimetickinfo.js';
    import * as d3 from 'd3';

    export let subplotLayout;
    export let xScale;

    let tickSizePrimary = 4;
    let tickSizeSecondary = 30;
    let showSecondaryTickMark = true;

    $: tickInfo = getDateTimeTickInfo(xScale);

    $: bottom = subplotLayout.y+subplotLayout.h;
    $: left = xScale.range()[0];
    $: right = xScale.range()[1];

    // Set formatting options based on whether the ticks are for
    //   time instances or intervals
    let textAnchor;
    let textOffsetX;
    let tickOffsetY;
    $: {
        if (tickInfo.tickformat_p.startsWith("%H:%M")) {
            textAnchor = "middle";
            textOffsetX = 0;
            tickOffsetY = 20;
        } else {
            textAnchor = "begin";
            textOffsetX = 12;
            tickOffsetY = 0;
        }
    }

    // Primary x-axis ticks
    $: primaryTicks = xScale.ticks(tickInfo.interval_p);
    $: secondaryTicks = xScale.ticks(tickInfo.interval_s);
    $: primaryFormatter = d3.utcFormat(tickInfo.tickformat_p);
    $: secondaryFormatter = d3.utcFormat(tickInfo.tickformat_s);

    // If there are no default secondary ticks (too far zoomed in on a day or month), show one at the left without a tick mark, for context
    $: {
        if (secondaryTicks.length == 0) {
            secondaryTicks = [xScale.domain()[0]];
            showSecondaryTickMark = false;
        } else {
            showSecondaryTickMark = true;
        }
    }

    // Day ticks
    let dayTicks = [];
    $: {
        if (tickInfo.tickformat_p.startsWith("%d") || tickInfo.tickformat_p.startsWith("%H")) {
            dayTicks = xScale.ticks(d3.utcDay);
        } else {
            dayTicks = [];
        }
    }
</script>

<!-- Add the day vertical bars -->
<g class="dayticks">
    {#each dayTicks as tick}
        <line x1={xScale(tick)}
              x2={xScale(tick)}
              y1={subplotLayout.y}
              y2={subplotLayout.y + subplotLayout.h}
              stroke="lightgray"
              stroke-opacity="50%"/>
    {/each}
</g>


<g class="xaxis">
    <!-- Horizontal axis line, spanning the full domain -->
    <line x1={left}
          x2={right}
          y1={bottom}
          y2={bottom}
          stroke='black'
          stroke-width='1.5px'/>

    <!-- Primary axis ticks -->
    {#each primaryTicks as tick}
        <line x1={xScale(tick)}
              x2={xScale(tick)}
              y1={subplotLayout.y+subplotLayout.h}
              y2={subplotLayout.y+subplotLayout.h+tickSizePrimary}
              stroke="black"
              stroke-width="0.75px"/>
        {#if (subplotLayout.xaxis_annotation=="visible" && tickInfo.visibility_annot_p == "visible")}
            <text x={xScale(tick)+textOffsetX}
                  y={subplotLayout.y+subplotLayout.h+tickSizePrimary+12}
                  font-size="12px"
                  text-anchor="{textAnchor}">{primaryFormatter(tick)}</text>
        {/if}
    {/each}

    <!-- Secondary axis ticks -->
    {#each secondaryTicks as tick}
        {#if subplotLayout.xaxis_annotation=="visible"}
            {#if showSecondaryTickMark}
                <line x1={xScale(tick)}
                      x2={xScale(tick)}
                      y1={subplotLayout.y+subplotLayout.h+tickOffsetY}
                      y2={subplotLayout.y+subplotLayout.h+tickSizeSecondary}
                      stroke="black"
                      stroke-width="0.75px"/>
            {/if}
            <text x={xScale(tick)+8}
                  y={subplotLayout.y+subplotLayout.h+tickSizePrimary+24}
                  font-size="12px"
                  text-anchor="begin">
                    {secondaryFormatter(tick)}
            </text>
        {:else}
            <line x1={xScale(tick)}
                  x2={xScale(tick)}
                  y1={subplotLayout.y+subplotLayout.h}
                  y2={subplotLayout.y+subplotLayout.h+tickSizeSecondary/2}
                  stroke="black"
                  stroke-width="0.75px"/>
        {/if}
    {/each}

</g>

